<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>Source code</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body>
<div class="sourceContainer">
<pre><span class="sourceLineNo">001</span>/*<a name="line.1"></a>
<span class="sourceLineNo">002</span> * Licensed to the Apache Software Foundation (ASF) under one or more<a name="line.2"></a>
<span class="sourceLineNo">003</span> * contributor license agreements.  See the NOTICE file distributed with<a name="line.3"></a>
<span class="sourceLineNo">004</span> * this work for additional information regarding copyright ownership.<a name="line.4"></a>
<span class="sourceLineNo">005</span> * The ASF licenses this file to You under the Apache License, Version 2.0<a name="line.5"></a>
<span class="sourceLineNo">006</span> * (the "License"); you may not use this file except in compliance with<a name="line.6"></a>
<span class="sourceLineNo">007</span> * the License.  You may obtain a copy of the License at<a name="line.7"></a>
<span class="sourceLineNo">008</span> *<a name="line.8"></a>
<span class="sourceLineNo">009</span> *      http://www.apache.org/licenses/LICENSE-2.0<a name="line.9"></a>
<span class="sourceLineNo">010</span> *<a name="line.10"></a>
<span class="sourceLineNo">011</span> * Unless required by applicable law or agreed to in writing, software<a name="line.11"></a>
<span class="sourceLineNo">012</span> * distributed under the License is distributed on an "AS IS" BASIS,<a name="line.12"></a>
<span class="sourceLineNo">013</span> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<a name="line.13"></a>
<span class="sourceLineNo">014</span> * See the License for the specific language governing permissions and<a name="line.14"></a>
<span class="sourceLineNo">015</span> * limitations under the License.<a name="line.15"></a>
<span class="sourceLineNo">016</span> */<a name="line.16"></a>
<span class="sourceLineNo">017</span><a name="line.17"></a>
<span class="sourceLineNo">018</span>package org.apache.commons.dbcp2;<a name="line.18"></a>
<span class="sourceLineNo">019</span><a name="line.19"></a>
<span class="sourceLineNo">020</span>import java.sql.Connection;<a name="line.20"></a>
<span class="sourceLineNo">021</span>import java.sql.SQLException;<a name="line.21"></a>
<span class="sourceLineNo">022</span>import java.sql.Statement;<a name="line.22"></a>
<span class="sourceLineNo">023</span>import java.util.Collection;<a name="line.23"></a>
<span class="sourceLineNo">024</span>import java.util.Objects;<a name="line.24"></a>
<span class="sourceLineNo">025</span>import java.util.concurrent.atomic.AtomicLong;<a name="line.25"></a>
<span class="sourceLineNo">026</span><a name="line.26"></a>
<span class="sourceLineNo">027</span>import javax.management.ObjectName;<a name="line.27"></a>
<span class="sourceLineNo">028</span><a name="line.28"></a>
<span class="sourceLineNo">029</span>import org.apache.commons.logging.Log;<a name="line.29"></a>
<span class="sourceLineNo">030</span>import org.apache.commons.logging.LogFactory;<a name="line.30"></a>
<span class="sourceLineNo">031</span>import org.apache.commons.pool2.KeyedObjectPool;<a name="line.31"></a>
<span class="sourceLineNo">032</span>import org.apache.commons.pool2.ObjectPool;<a name="line.32"></a>
<span class="sourceLineNo">033</span>import org.apache.commons.pool2.PooledObject;<a name="line.33"></a>
<span class="sourceLineNo">034</span>import org.apache.commons.pool2.PooledObjectFactory;<a name="line.34"></a>
<span class="sourceLineNo">035</span>import org.apache.commons.pool2.impl.DefaultPooledObject;<a name="line.35"></a>
<span class="sourceLineNo">036</span>import org.apache.commons.pool2.impl.GenericKeyedObjectPool;<a name="line.36"></a>
<span class="sourceLineNo">037</span>import org.apache.commons.pool2.impl.GenericKeyedObjectPoolConfig;<a name="line.37"></a>
<span class="sourceLineNo">038</span><a name="line.38"></a>
<span class="sourceLineNo">039</span>/**<a name="line.39"></a>
<span class="sourceLineNo">040</span> * A {@link PooledObjectFactory} that creates {@link PoolableConnection}s.<a name="line.40"></a>
<span class="sourceLineNo">041</span> *<a name="line.41"></a>
<span class="sourceLineNo">042</span> * @since 2.0<a name="line.42"></a>
<span class="sourceLineNo">043</span> */<a name="line.43"></a>
<span class="sourceLineNo">044</span>public class PoolableConnectionFactory implements PooledObjectFactory&lt;PoolableConnection&gt; {<a name="line.44"></a>
<span class="sourceLineNo">045</span><a name="line.45"></a>
<span class="sourceLineNo">046</span>    private static final Log log = LogFactory.getLog(PoolableConnectionFactory.class);<a name="line.46"></a>
<span class="sourceLineNo">047</span><a name="line.47"></a>
<span class="sourceLineNo">048</span>    /**<a name="line.48"></a>
<span class="sourceLineNo">049</span>     * Internal constant to indicate the level is not set.<a name="line.49"></a>
<span class="sourceLineNo">050</span>     */<a name="line.50"></a>
<span class="sourceLineNo">051</span>    static final int UNKNOWN_TRANSACTION_ISOLATION = -1;<a name="line.51"></a>
<span class="sourceLineNo">052</span><a name="line.52"></a>
<span class="sourceLineNo">053</span>    private final ConnectionFactory connectionFactory;<a name="line.53"></a>
<span class="sourceLineNo">054</span><a name="line.54"></a>
<span class="sourceLineNo">055</span>    private final ObjectName dataSourceJmxObjectName;<a name="line.55"></a>
<span class="sourceLineNo">056</span><a name="line.56"></a>
<span class="sourceLineNo">057</span>    private volatile String validationQuery;<a name="line.57"></a>
<span class="sourceLineNo">058</span><a name="line.58"></a>
<span class="sourceLineNo">059</span>    private volatile int validationQueryTimeoutSeconds = -1;<a name="line.59"></a>
<span class="sourceLineNo">060</span><a name="line.60"></a>
<span class="sourceLineNo">061</span>    private Collection&lt;String&gt; connectionInitSqls;<a name="line.61"></a>
<span class="sourceLineNo">062</span><a name="line.62"></a>
<span class="sourceLineNo">063</span>    private Collection&lt;String&gt; disconnectionSqlCodes;<a name="line.63"></a>
<span class="sourceLineNo">064</span><a name="line.64"></a>
<span class="sourceLineNo">065</span>    private boolean fastFailValidation = true;<a name="line.65"></a>
<span class="sourceLineNo">066</span><a name="line.66"></a>
<span class="sourceLineNo">067</span>    private volatile ObjectPool&lt;PoolableConnection&gt; pool;<a name="line.67"></a>
<span class="sourceLineNo">068</span><a name="line.68"></a>
<span class="sourceLineNo">069</span>    private Boolean defaultReadOnly;<a name="line.69"></a>
<span class="sourceLineNo">070</span><a name="line.70"></a>
<span class="sourceLineNo">071</span>    private Boolean defaultAutoCommit;<a name="line.71"></a>
<span class="sourceLineNo">072</span><a name="line.72"></a>
<span class="sourceLineNo">073</span>    private boolean autoCommitOnReturn = true;<a name="line.73"></a>
<span class="sourceLineNo">074</span><a name="line.74"></a>
<span class="sourceLineNo">075</span>    private boolean rollbackOnReturn = true;<a name="line.75"></a>
<span class="sourceLineNo">076</span><a name="line.76"></a>
<span class="sourceLineNo">077</span>    private int defaultTransactionIsolation = UNKNOWN_TRANSACTION_ISOLATION;<a name="line.77"></a>
<span class="sourceLineNo">078</span><a name="line.78"></a>
<span class="sourceLineNo">079</span>    private String defaultCatalog;<a name="line.79"></a>
<span class="sourceLineNo">080</span><a name="line.80"></a>
<span class="sourceLineNo">081</span>    private String defaultSchema;<a name="line.81"></a>
<span class="sourceLineNo">082</span><a name="line.82"></a>
<span class="sourceLineNo">083</span>    private boolean cacheState;<a name="line.83"></a>
<span class="sourceLineNo">084</span><a name="line.84"></a>
<span class="sourceLineNo">085</span>    private boolean poolStatements;<a name="line.85"></a>
<span class="sourceLineNo">086</span><a name="line.86"></a>
<span class="sourceLineNo">087</span>    private boolean clearStatementPoolOnReturn;<a name="line.87"></a>
<span class="sourceLineNo">088</span><a name="line.88"></a>
<span class="sourceLineNo">089</span>    private int maxOpenPreparedStatements = GenericKeyedObjectPoolConfig.DEFAULT_MAX_TOTAL_PER_KEY;<a name="line.89"></a>
<span class="sourceLineNo">090</span><a name="line.90"></a>
<span class="sourceLineNo">091</span>    private long maxConnLifetimeMillis = -1;<a name="line.91"></a>
<span class="sourceLineNo">092</span><a name="line.92"></a>
<span class="sourceLineNo">093</span>    private final AtomicLong connectionIndex = new AtomicLong(0);<a name="line.93"></a>
<span class="sourceLineNo">094</span><a name="line.94"></a>
<span class="sourceLineNo">095</span>    private Integer defaultQueryTimeoutSeconds;<a name="line.95"></a>
<span class="sourceLineNo">096</span><a name="line.96"></a>
<span class="sourceLineNo">097</span>    /**<a name="line.97"></a>
<span class="sourceLineNo">098</span>     * Creates a new {@code PoolableConnectionFactory}.<a name="line.98"></a>
<span class="sourceLineNo">099</span>     *<a name="line.99"></a>
<span class="sourceLineNo">100</span>     * @param connFactory<a name="line.100"></a>
<span class="sourceLineNo">101</span>     *            the {@link ConnectionFactory} from which to obtain base {@link Connection}s<a name="line.101"></a>
<span class="sourceLineNo">102</span>     * @param dataSourceJmxObjectName<a name="line.102"></a>
<span class="sourceLineNo">103</span>     *            The JMX object name, may be null.<a name="line.103"></a>
<span class="sourceLineNo">104</span>     */<a name="line.104"></a>
<span class="sourceLineNo">105</span>    public PoolableConnectionFactory(final ConnectionFactory connFactory, final ObjectName dataSourceJmxObjectName) {<a name="line.105"></a>
<span class="sourceLineNo">106</span>        this.connectionFactory = connFactory;<a name="line.106"></a>
<span class="sourceLineNo">107</span>        this.dataSourceJmxObjectName = dataSourceJmxObjectName;<a name="line.107"></a>
<span class="sourceLineNo">108</span>    }<a name="line.108"></a>
<span class="sourceLineNo">109</span><a name="line.109"></a>
<span class="sourceLineNo">110</span>    @Override<a name="line.110"></a>
<span class="sourceLineNo">111</span>    public void activateObject(final PooledObject&lt;PoolableConnection&gt; p) throws Exception {<a name="line.111"></a>
<span class="sourceLineNo">112</span><a name="line.112"></a>
<span class="sourceLineNo">113</span>        validateLifetime(p);<a name="line.113"></a>
<span class="sourceLineNo">114</span><a name="line.114"></a>
<span class="sourceLineNo">115</span>        final PoolableConnection conn = p.getObject();<a name="line.115"></a>
<span class="sourceLineNo">116</span>        conn.activate();<a name="line.116"></a>
<span class="sourceLineNo">117</span><a name="line.117"></a>
<span class="sourceLineNo">118</span>        if (defaultAutoCommit != null &amp;&amp; conn.getAutoCommit() != defaultAutoCommit.booleanValue()) {<a name="line.118"></a>
<span class="sourceLineNo">119</span>            conn.setAutoCommit(defaultAutoCommit.booleanValue());<a name="line.119"></a>
<span class="sourceLineNo">120</span>        }<a name="line.120"></a>
<span class="sourceLineNo">121</span>        if (defaultTransactionIsolation != UNKNOWN_TRANSACTION_ISOLATION<a name="line.121"></a>
<span class="sourceLineNo">122</span>                &amp;&amp; conn.getTransactionIsolation() != defaultTransactionIsolation) {<a name="line.122"></a>
<span class="sourceLineNo">123</span>            conn.setTransactionIsolation(defaultTransactionIsolation);<a name="line.123"></a>
<span class="sourceLineNo">124</span>        }<a name="line.124"></a>
<span class="sourceLineNo">125</span>        if (defaultReadOnly != null &amp;&amp; conn.isReadOnly() != defaultReadOnly.booleanValue()) {<a name="line.125"></a>
<span class="sourceLineNo">126</span>            conn.setReadOnly(defaultReadOnly.booleanValue());<a name="line.126"></a>
<span class="sourceLineNo">127</span>        }<a name="line.127"></a>
<span class="sourceLineNo">128</span>        if (defaultCatalog != null &amp;&amp; !defaultCatalog.equals(conn.getCatalog())) {<a name="line.128"></a>
<span class="sourceLineNo">129</span>            conn.setCatalog(defaultCatalog);<a name="line.129"></a>
<span class="sourceLineNo">130</span>        }<a name="line.130"></a>
<span class="sourceLineNo">131</span>        if (defaultSchema != null &amp;&amp; !defaultSchema.equals(Jdbc41Bridge.getSchema(conn))) {<a name="line.131"></a>
<span class="sourceLineNo">132</span>            Jdbc41Bridge.setSchema(conn, defaultSchema);<a name="line.132"></a>
<span class="sourceLineNo">133</span>        }<a name="line.133"></a>
<span class="sourceLineNo">134</span>        conn.setDefaultQueryTimeout(defaultQueryTimeoutSeconds);<a name="line.134"></a>
<span class="sourceLineNo">135</span>    }<a name="line.135"></a>
<span class="sourceLineNo">136</span><a name="line.136"></a>
<span class="sourceLineNo">137</span>    @Override<a name="line.137"></a>
<span class="sourceLineNo">138</span>    public void destroyObject(final PooledObject&lt;PoolableConnection&gt; p) throws Exception {<a name="line.138"></a>
<span class="sourceLineNo">139</span>        p.getObject().reallyClose();<a name="line.139"></a>
<span class="sourceLineNo">140</span>    }<a name="line.140"></a>
<span class="sourceLineNo">141</span><a name="line.141"></a>
<span class="sourceLineNo">142</span>    /**<a name="line.142"></a>
<span class="sourceLineNo">143</span>     * @return The cache state.<a name="line.143"></a>
<span class="sourceLineNo">144</span>     * @since Made public in 2.6.0.<a name="line.144"></a>
<span class="sourceLineNo">145</span>     */<a name="line.145"></a>
<span class="sourceLineNo">146</span>    public boolean getCacheState() {<a name="line.146"></a>
<span class="sourceLineNo">147</span>        return cacheState;<a name="line.147"></a>
<span class="sourceLineNo">148</span>    }<a name="line.148"></a>
<span class="sourceLineNo">149</span><a name="line.149"></a>
<span class="sourceLineNo">150</span>    /**<a name="line.150"></a>
<span class="sourceLineNo">151</span>     * @return The connection factory.<a name="line.151"></a>
<span class="sourceLineNo">152</span>     * @since Made public in 2.6.0.<a name="line.152"></a>
<span class="sourceLineNo">153</span>     */<a name="line.153"></a>
<span class="sourceLineNo">154</span>    public ConnectionFactory getConnectionFactory() {<a name="line.154"></a>
<span class="sourceLineNo">155</span>        return connectionFactory;<a name="line.155"></a>
<span class="sourceLineNo">156</span>    }<a name="line.156"></a>
<span class="sourceLineNo">157</span><a name="line.157"></a>
<span class="sourceLineNo">158</span>    protected AtomicLong getConnectionIndex() {<a name="line.158"></a>
<span class="sourceLineNo">159</span>        return connectionIndex;<a name="line.159"></a>
<span class="sourceLineNo">160</span>    }<a name="line.160"></a>
<span class="sourceLineNo">161</span><a name="line.161"></a>
<span class="sourceLineNo">162</span>    /**<a name="line.162"></a>
<span class="sourceLineNo">163</span>     * @return The collection of initialization SQL statements.<a name="line.163"></a>
<span class="sourceLineNo">164</span>     * @since 2.6.0<a name="line.164"></a>
<span class="sourceLineNo">165</span>     */<a name="line.165"></a>
<span class="sourceLineNo">166</span>    public Collection&lt;String&gt; getConnectionInitSqls() {<a name="line.166"></a>
<span class="sourceLineNo">167</span>        return connectionInitSqls;<a name="line.167"></a>
<span class="sourceLineNo">168</span>    }<a name="line.168"></a>
<span class="sourceLineNo">169</span><a name="line.169"></a>
<span class="sourceLineNo">170</span>    /**<a name="line.170"></a>
<span class="sourceLineNo">171</span>     * @return The data source JMX ObjectName<a name="line.171"></a>
<span class="sourceLineNo">172</span>     * @since Made public in 2.6.0.<a name="line.172"></a>
<span class="sourceLineNo">173</span>     */<a name="line.173"></a>
<span class="sourceLineNo">174</span>    public ObjectName getDataSourceJmxName() {<a name="line.174"></a>
<span class="sourceLineNo">175</span>        return dataSourceJmxObjectName;<a name="line.175"></a>
<span class="sourceLineNo">176</span>    }<a name="line.176"></a>
<span class="sourceLineNo">177</span><a name="line.177"></a>
<span class="sourceLineNo">178</span>    /**<a name="line.178"></a>
<span class="sourceLineNo">179</span>     * @return The data source JMS ObjectName.<a name="line.179"></a>
<span class="sourceLineNo">180</span>     * @since 2.6.0<a name="line.180"></a>
<span class="sourceLineNo">181</span>     */<a name="line.181"></a>
<span class="sourceLineNo">182</span>    public ObjectName getDataSourceJmxObjectName() {<a name="line.182"></a>
<span class="sourceLineNo">183</span>        return dataSourceJmxObjectName;<a name="line.183"></a>
<span class="sourceLineNo">184</span>    }<a name="line.184"></a>
<span class="sourceLineNo">185</span><a name="line.185"></a>
<span class="sourceLineNo">186</span>    /**<a name="line.186"></a>
<span class="sourceLineNo">187</span>     * @return Default auto-commit value.<a name="line.187"></a>
<span class="sourceLineNo">188</span>     * @since 2.6.0<a name="line.188"></a>
<span class="sourceLineNo">189</span>     */<a name="line.189"></a>
<span class="sourceLineNo">190</span>    public Boolean getDefaultAutoCommit() {<a name="line.190"></a>
<span class="sourceLineNo">191</span>        return defaultAutoCommit;<a name="line.191"></a>
<span class="sourceLineNo">192</span>    }<a name="line.192"></a>
<span class="sourceLineNo">193</span><a name="line.193"></a>
<span class="sourceLineNo">194</span>    /**<a name="line.194"></a>
<span class="sourceLineNo">195</span>     * @return Default catalog.<a name="line.195"></a>
<span class="sourceLineNo">196</span>     * @since 2.6.0<a name="line.196"></a>
<span class="sourceLineNo">197</span>     */<a name="line.197"></a>
<span class="sourceLineNo">198</span>    public String getDefaultCatalog() {<a name="line.198"></a>
<span class="sourceLineNo">199</span>        return defaultCatalog;<a name="line.199"></a>
<span class="sourceLineNo">200</span>    }<a name="line.200"></a>
<span class="sourceLineNo">201</span><a name="line.201"></a>
<span class="sourceLineNo">202</span>    /**<a name="line.202"></a>
<span class="sourceLineNo">203</span>     * @return Default query timeout in seconds.<a name="line.203"></a>
<span class="sourceLineNo">204</span>     */<a name="line.204"></a>
<span class="sourceLineNo">205</span>    public Integer getDefaultQueryTimeout() {<a name="line.205"></a>
<span class="sourceLineNo">206</span>        return defaultQueryTimeoutSeconds;<a name="line.206"></a>
<span class="sourceLineNo">207</span>    }<a name="line.207"></a>
<span class="sourceLineNo">208</span><a name="line.208"></a>
<span class="sourceLineNo">209</span>    /**<a name="line.209"></a>
<span class="sourceLineNo">210</span>     * @return Default query timeout in seconds.<a name="line.210"></a>
<span class="sourceLineNo">211</span>     * @since 2.6.0<a name="line.211"></a>
<span class="sourceLineNo">212</span>     */<a name="line.212"></a>
<span class="sourceLineNo">213</span>    public Integer getDefaultQueryTimeoutSeconds() {<a name="line.213"></a>
<span class="sourceLineNo">214</span>        return defaultQueryTimeoutSeconds;<a name="line.214"></a>
<span class="sourceLineNo">215</span>    }<a name="line.215"></a>
<span class="sourceLineNo">216</span><a name="line.216"></a>
<span class="sourceLineNo">217</span>    /**<a name="line.217"></a>
<span class="sourceLineNo">218</span>     * @return Default read-only-value.<a name="line.218"></a>
<span class="sourceLineNo">219</span>     * @since 2.6.0<a name="line.219"></a>
<span class="sourceLineNo">220</span>     */<a name="line.220"></a>
<span class="sourceLineNo">221</span>    public Boolean getDefaultReadOnly() {<a name="line.221"></a>
<span class="sourceLineNo">222</span>        return defaultReadOnly;<a name="line.222"></a>
<span class="sourceLineNo">223</span>    }<a name="line.223"></a>
<span class="sourceLineNo">224</span><a name="line.224"></a>
<span class="sourceLineNo">225</span>    /**<a name="line.225"></a>
<span class="sourceLineNo">226</span>     * @return Default schema.<a name="line.226"></a>
<span class="sourceLineNo">227</span>     * @since 2.6.0<a name="line.227"></a>
<span class="sourceLineNo">228</span>     */<a name="line.228"></a>
<span class="sourceLineNo">229</span>    public String getDefaultSchema() {<a name="line.229"></a>
<span class="sourceLineNo">230</span>        return defaultSchema;<a name="line.230"></a>
<span class="sourceLineNo">231</span>    }<a name="line.231"></a>
<span class="sourceLineNo">232</span><a name="line.232"></a>
<span class="sourceLineNo">233</span>    /**<a name="line.233"></a>
<span class="sourceLineNo">234</span>     * @return Default transaction isolation.<a name="line.234"></a>
<span class="sourceLineNo">235</span>     * @since 2.6.0<a name="line.235"></a>
<span class="sourceLineNo">236</span>     */<a name="line.236"></a>
<span class="sourceLineNo">237</span>    public int getDefaultTransactionIsolation() {<a name="line.237"></a>
<span class="sourceLineNo">238</span>        return defaultTransactionIsolation;<a name="line.238"></a>
<span class="sourceLineNo">239</span>    }<a name="line.239"></a>
<span class="sourceLineNo">240</span><a name="line.240"></a>
<span class="sourceLineNo">241</span>    /**<a name="line.241"></a>
<span class="sourceLineNo">242</span>     * SQL_STATE codes considered to signal fatal conditions.<a name="line.242"></a>
<span class="sourceLineNo">243</span>     * &lt;p&gt;<a name="line.243"></a>
<span class="sourceLineNo">244</span>     * Overrides the defaults in {@link Utils#DISCONNECTION_SQL_CODES} (plus anything starting with<a name="line.244"></a>
<span class="sourceLineNo">245</span>     * {@link Utils#DISCONNECTION_SQL_CODE_PREFIX}). If this property is non-null and {@link #isFastFailValidation()} is<a name="line.245"></a>
<span class="sourceLineNo">246</span>     * {@code true}, whenever connections created by this factory generate exceptions with SQL_STATE codes in this list,<a name="line.246"></a>
<span class="sourceLineNo">247</span>     * they will be marked as "fatally disconnected" and subsequent validations will fail fast (no attempt at isValid or<a name="line.247"></a>
<span class="sourceLineNo">248</span>     * validation query).<a name="line.248"></a>
<span class="sourceLineNo">249</span>     * &lt;/p&gt;<a name="line.249"></a>
<span class="sourceLineNo">250</span>     * &lt;p&gt;<a name="line.250"></a>
<span class="sourceLineNo">251</span>     * If {@link #isFastFailValidation()} is {@code false} setting this property has no effect.<a name="line.251"></a>
<span class="sourceLineNo">252</span>     * &lt;/p&gt;<a name="line.252"></a>
<span class="sourceLineNo">253</span>     *<a name="line.253"></a>
<span class="sourceLineNo">254</span>     * @return SQL_STATE codes overriding defaults<a name="line.254"></a>
<span class="sourceLineNo">255</span>     * @since 2.1<a name="line.255"></a>
<span class="sourceLineNo">256</span>     */<a name="line.256"></a>
<span class="sourceLineNo">257</span>    public Collection&lt;String&gt; getDisconnectionSqlCodes() {<a name="line.257"></a>
<span class="sourceLineNo">258</span>        return disconnectionSqlCodes;<a name="line.258"></a>
<span class="sourceLineNo">259</span>    }<a name="line.259"></a>
<span class="sourceLineNo">260</span><a name="line.260"></a>
<span class="sourceLineNo">261</span>    /**<a name="line.261"></a>
<span class="sourceLineNo">262</span>     * @return Maximum connection lifetime in milliseconds.<a name="line.262"></a>
<span class="sourceLineNo">263</span>     * @since 2.6.0<a name="line.263"></a>
<span class="sourceLineNo">264</span>     */<a name="line.264"></a>
<span class="sourceLineNo">265</span>    public long getMaxConnLifetimeMillis() {<a name="line.265"></a>
<span class="sourceLineNo">266</span>        return maxConnLifetimeMillis;<a name="line.266"></a>
<span class="sourceLineNo">267</span>    }<a name="line.267"></a>
<span class="sourceLineNo">268</span><a name="line.268"></a>
<span class="sourceLineNo">269</span>    protected int getMaxOpenPreparedStatements() {<a name="line.269"></a>
<span class="sourceLineNo">270</span>        return maxOpenPreparedStatements;<a name="line.270"></a>
<span class="sourceLineNo">271</span>    }<a name="line.271"></a>
<span class="sourceLineNo">272</span><a name="line.272"></a>
<span class="sourceLineNo">273</span>    /**<a name="line.273"></a>
<span class="sourceLineNo">274</span>     * Returns the {@link ObjectPool} in which {@link Connection}s are pooled.<a name="line.274"></a>
<span class="sourceLineNo">275</span>     *<a name="line.275"></a>
<span class="sourceLineNo">276</span>     * @return the connection pool<a name="line.276"></a>
<span class="sourceLineNo">277</span>     */<a name="line.277"></a>
<span class="sourceLineNo">278</span>    public synchronized ObjectPool&lt;PoolableConnection&gt; getPool() {<a name="line.278"></a>
<span class="sourceLineNo">279</span>        return pool;<a name="line.279"></a>
<span class="sourceLineNo">280</span>    }<a name="line.280"></a>
<span class="sourceLineNo">281</span><a name="line.281"></a>
<span class="sourceLineNo">282</span>    /**<a name="line.282"></a>
<span class="sourceLineNo">283</span>     * @return Whether to pool statements.<a name="line.283"></a>
<span class="sourceLineNo">284</span>     * @since Made public in 2.6.0.<a name="line.284"></a>
<span class="sourceLineNo">285</span>     */<a name="line.285"></a>
<span class="sourceLineNo">286</span>    public boolean getPoolStatements() {<a name="line.286"></a>
<span class="sourceLineNo">287</span>        return poolStatements;<a name="line.287"></a>
<span class="sourceLineNo">288</span>    }<a name="line.288"></a>
<span class="sourceLineNo">289</span>    /**<a name="line.289"></a>
<span class="sourceLineNo">290</span>     * @return Validation query.<a name="line.290"></a>
<span class="sourceLineNo">291</span>     * @since 2.6.0<a name="line.291"></a>
<span class="sourceLineNo">292</span>     */<a name="line.292"></a>
<span class="sourceLineNo">293</span>    public String getValidationQuery() {<a name="line.293"></a>
<span class="sourceLineNo">294</span>        return validationQuery;<a name="line.294"></a>
<span class="sourceLineNo">295</span>    }<a name="line.295"></a>
<span class="sourceLineNo">296</span>    /**<a name="line.296"></a>
<span class="sourceLineNo">297</span>     * @return Validation query timeout in seconds.<a name="line.297"></a>
<span class="sourceLineNo">298</span>     * @since 2.6.0<a name="line.298"></a>
<span class="sourceLineNo">299</span>     */<a name="line.299"></a>
<span class="sourceLineNo">300</span>    public int getValidationQueryTimeoutSeconds() {<a name="line.300"></a>
<span class="sourceLineNo">301</span>        return validationQueryTimeoutSeconds;<a name="line.301"></a>
<span class="sourceLineNo">302</span>    }<a name="line.302"></a>
<span class="sourceLineNo">303</span>    protected void initializeConnection(final Connection conn) throws SQLException {<a name="line.303"></a>
<span class="sourceLineNo">304</span>        final Collection&lt;String&gt; sqls = connectionInitSqls;<a name="line.304"></a>
<span class="sourceLineNo">305</span>        if (conn.isClosed()) {<a name="line.305"></a>
<span class="sourceLineNo">306</span>            throw new SQLException("initializeConnection: connection closed");<a name="line.306"></a>
<span class="sourceLineNo">307</span>        }<a name="line.307"></a>
<span class="sourceLineNo">308</span>        if (null != sqls) {<a name="line.308"></a>
<span class="sourceLineNo">309</span>            try (Statement stmt = conn.createStatement()) {<a name="line.309"></a>
<span class="sourceLineNo">310</span>                for (final String sql : sqls) {<a name="line.310"></a>
<span class="sourceLineNo">311</span>                    Objects.requireNonNull(sql, "null connectionInitSqls element");<a name="line.311"></a>
<span class="sourceLineNo">312</span>                    stmt.execute(sql);<a name="line.312"></a>
<span class="sourceLineNo">313</span>                }<a name="line.313"></a>
<span class="sourceLineNo">314</span>            }<a name="line.314"></a>
<span class="sourceLineNo">315</span>        }<a name="line.315"></a>
<span class="sourceLineNo">316</span>    }<a name="line.316"></a>
<span class="sourceLineNo">317</span><a name="line.317"></a>
<span class="sourceLineNo">318</span>    /**<a name="line.318"></a>
<span class="sourceLineNo">319</span>     * @return Whether to auto-commit on return.<a name="line.319"></a>
<span class="sourceLineNo">320</span>     * @since 2.6.0<a name="line.320"></a>
<span class="sourceLineNo">321</span>     */<a name="line.321"></a>
<span class="sourceLineNo">322</span>    public boolean isAutoCommitOnReturn() {<a name="line.322"></a>
<span class="sourceLineNo">323</span>        return autoCommitOnReturn;<a name="line.323"></a>
<span class="sourceLineNo">324</span>    }<a name="line.324"></a>
<span class="sourceLineNo">325</span><a name="line.325"></a>
<span class="sourceLineNo">326</span>    /**<a name="line.326"></a>
<span class="sourceLineNo">327</span>     * @return Whether to auto-commit on return.<a name="line.327"></a>
<span class="sourceLineNo">328</span>     * @deprecated Use {@link #isAutoCommitOnReturn()}.<a name="line.328"></a>
<span class="sourceLineNo">329</span>     */<a name="line.329"></a>
<span class="sourceLineNo">330</span>    @Deprecated<a name="line.330"></a>
<span class="sourceLineNo">331</span>    public boolean isEnableAutoCommitOnReturn() {<a name="line.331"></a>
<span class="sourceLineNo">332</span>        return autoCommitOnReturn;<a name="line.332"></a>
<span class="sourceLineNo">333</span>    }<a name="line.333"></a>
<span class="sourceLineNo">334</span><a name="line.334"></a>
<span class="sourceLineNo">335</span>    /**<a name="line.335"></a>
<span class="sourceLineNo">336</span>     * True means that validation will fail immediately for connections that have previously thrown SQLExceptions with<a name="line.336"></a>
<span class="sourceLineNo">337</span>     * SQL_STATE indicating fatal disconnection errors.<a name="line.337"></a>
<span class="sourceLineNo">338</span>     *<a name="line.338"></a>
<span class="sourceLineNo">339</span>     * @return true if connections created by this factory will fast fail validation.<a name="line.339"></a>
<span class="sourceLineNo">340</span>     * @see #setDisconnectionSqlCodes(Collection)<a name="line.340"></a>
<span class="sourceLineNo">341</span>     * @since 2.1<a name="line.341"></a>
<span class="sourceLineNo">342</span>     * @since 2.5.0 Defaults to true, previous versions defaulted to false.<a name="line.342"></a>
<span class="sourceLineNo">343</span>     */<a name="line.343"></a>
<span class="sourceLineNo">344</span>    public boolean isFastFailValidation() {<a name="line.344"></a>
<span class="sourceLineNo">345</span>        return fastFailValidation;<a name="line.345"></a>
<span class="sourceLineNo">346</span>    }<a name="line.346"></a>
<span class="sourceLineNo">347</span><a name="line.347"></a>
<span class="sourceLineNo">348</span>    /**<a name="line.348"></a>
<span class="sourceLineNo">349</span>     * @return Whether to rollback on return.<a name="line.349"></a>
<span class="sourceLineNo">350</span>     */<a name="line.350"></a>
<span class="sourceLineNo">351</span>    public boolean isRollbackOnReturn() {<a name="line.351"></a>
<span class="sourceLineNo">352</span>        return rollbackOnReturn;<a name="line.352"></a>
<span class="sourceLineNo">353</span>    }<a name="line.353"></a>
<span class="sourceLineNo">354</span><a name="line.354"></a>
<span class="sourceLineNo">355</span>    @Override<a name="line.355"></a>
<span class="sourceLineNo">356</span>    public PooledObject&lt;PoolableConnection&gt; makeObject() throws Exception {<a name="line.356"></a>
<span class="sourceLineNo">357</span>        Connection conn = connectionFactory.createConnection();<a name="line.357"></a>
<span class="sourceLineNo">358</span>        if (conn == null) {<a name="line.358"></a>
<span class="sourceLineNo">359</span>            throw new IllegalStateException("Connection factory returned null from createConnection");<a name="line.359"></a>
<span class="sourceLineNo">360</span>        }<a name="line.360"></a>
<span class="sourceLineNo">361</span>        try {<a name="line.361"></a>
<span class="sourceLineNo">362</span>            initializeConnection(conn);<a name="line.362"></a>
<span class="sourceLineNo">363</span>        } catch (final SQLException sqle) {<a name="line.363"></a>
<span class="sourceLineNo">364</span>            // Make sure the connection is closed<a name="line.364"></a>
<span class="sourceLineNo">365</span>            try {<a name="line.365"></a>
<span class="sourceLineNo">366</span>                conn.close();<a name="line.366"></a>
<span class="sourceLineNo">367</span>            } catch (final SQLException ignore) {<a name="line.367"></a>
<span class="sourceLineNo">368</span>                // ignore<a name="line.368"></a>
<span class="sourceLineNo">369</span>            }<a name="line.369"></a>
<span class="sourceLineNo">370</span>            // Rethrow original exception so it is visible to caller<a name="line.370"></a>
<span class="sourceLineNo">371</span>            throw sqle;<a name="line.371"></a>
<span class="sourceLineNo">372</span>        }<a name="line.372"></a>
<span class="sourceLineNo">373</span><a name="line.373"></a>
<span class="sourceLineNo">374</span>        final long connIndex = connectionIndex.getAndIncrement();<a name="line.374"></a>
<span class="sourceLineNo">375</span><a name="line.375"></a>
<span class="sourceLineNo">376</span>        if (poolStatements) {<a name="line.376"></a>
<span class="sourceLineNo">377</span>            conn = new PoolingConnection(conn);<a name="line.377"></a>
<span class="sourceLineNo">378</span>            final GenericKeyedObjectPoolConfig&lt;DelegatingPreparedStatement&gt; config = new GenericKeyedObjectPoolConfig&lt;&gt;();<a name="line.378"></a>
<span class="sourceLineNo">379</span>            config.setMaxTotalPerKey(-1);<a name="line.379"></a>
<span class="sourceLineNo">380</span>            config.setBlockWhenExhausted(false);<a name="line.380"></a>
<span class="sourceLineNo">381</span>            config.setMaxWaitMillis(0);<a name="line.381"></a>
<span class="sourceLineNo">382</span>            config.setMaxIdlePerKey(1);<a name="line.382"></a>
<span class="sourceLineNo">383</span>            config.setMaxTotal(maxOpenPreparedStatements);<a name="line.383"></a>
<span class="sourceLineNo">384</span>            if (dataSourceJmxObjectName != null) {<a name="line.384"></a>
<span class="sourceLineNo">385</span>                final StringBuilder base = new StringBuilder(dataSourceJmxObjectName.toString());<a name="line.385"></a>
<span class="sourceLineNo">386</span>                base.append(Constants.JMX_CONNECTION_BASE_EXT);<a name="line.386"></a>
<span class="sourceLineNo">387</span>                base.append(Long.toString(connIndex));<a name="line.387"></a>
<span class="sourceLineNo">388</span>                config.setJmxNameBase(base.toString());<a name="line.388"></a>
<span class="sourceLineNo">389</span>                config.setJmxNamePrefix(Constants.JMX_STATEMENT_POOL_PREFIX);<a name="line.389"></a>
<span class="sourceLineNo">390</span>            } else {<a name="line.390"></a>
<span class="sourceLineNo">391</span>                config.setJmxEnabled(false);<a name="line.391"></a>
<span class="sourceLineNo">392</span>            }<a name="line.392"></a>
<span class="sourceLineNo">393</span>            final PoolingConnection poolingConn = (PoolingConnection) conn;<a name="line.393"></a>
<span class="sourceLineNo">394</span>            final KeyedObjectPool&lt;PStmtKey, DelegatingPreparedStatement&gt; stmtPool = new GenericKeyedObjectPool&lt;&gt;(<a name="line.394"></a>
<span class="sourceLineNo">395</span>                    poolingConn, config);<a name="line.395"></a>
<span class="sourceLineNo">396</span>            poolingConn.setStatementPool(stmtPool);<a name="line.396"></a>
<span class="sourceLineNo">397</span>            poolingConn.setClearStatementPoolOnReturn(clearStatementPoolOnReturn);<a name="line.397"></a>
<span class="sourceLineNo">398</span>            poolingConn.setCacheState(cacheState);<a name="line.398"></a>
<span class="sourceLineNo">399</span>        }<a name="line.399"></a>
<span class="sourceLineNo">400</span><a name="line.400"></a>
<span class="sourceLineNo">401</span>        // Register this connection with JMX<a name="line.401"></a>
<span class="sourceLineNo">402</span>        ObjectName connJmxName;<a name="line.402"></a>
<span class="sourceLineNo">403</span>        if (dataSourceJmxObjectName == null) {<a name="line.403"></a>
<span class="sourceLineNo">404</span>            connJmxName = null;<a name="line.404"></a>
<span class="sourceLineNo">405</span>        } else {<a name="line.405"></a>
<span class="sourceLineNo">406</span>            connJmxName = new ObjectName(<a name="line.406"></a>
<span class="sourceLineNo">407</span>                    dataSourceJmxObjectName.toString() + Constants.JMX_CONNECTION_BASE_EXT + connIndex);<a name="line.407"></a>
<span class="sourceLineNo">408</span>        }<a name="line.408"></a>
<span class="sourceLineNo">409</span><a name="line.409"></a>
<span class="sourceLineNo">410</span>        final PoolableConnection pc = new PoolableConnection(conn, pool, connJmxName, disconnectionSqlCodes,<a name="line.410"></a>
<span class="sourceLineNo">411</span>                fastFailValidation);<a name="line.411"></a>
<span class="sourceLineNo">412</span>        pc.setCacheState(cacheState);<a name="line.412"></a>
<span class="sourceLineNo">413</span><a name="line.413"></a>
<span class="sourceLineNo">414</span>        return new DefaultPooledObject&lt;&gt;(pc);<a name="line.414"></a>
<span class="sourceLineNo">415</span>    }<a name="line.415"></a>
<span class="sourceLineNo">416</span><a name="line.416"></a>
<span class="sourceLineNo">417</span>    @Override<a name="line.417"></a>
<span class="sourceLineNo">418</span>    public void passivateObject(final PooledObject&lt;PoolableConnection&gt; p) throws Exception {<a name="line.418"></a>
<span class="sourceLineNo">419</span><a name="line.419"></a>
<span class="sourceLineNo">420</span>        validateLifetime(p);<a name="line.420"></a>
<span class="sourceLineNo">421</span><a name="line.421"></a>
<span class="sourceLineNo">422</span>        final PoolableConnection conn = p.getObject();<a name="line.422"></a>
<span class="sourceLineNo">423</span>        Boolean connAutoCommit = null;<a name="line.423"></a>
<span class="sourceLineNo">424</span>        if (rollbackOnReturn) {<a name="line.424"></a>
<span class="sourceLineNo">425</span>            connAutoCommit = Boolean.valueOf(conn.getAutoCommit());<a name="line.425"></a>
<span class="sourceLineNo">426</span>            if (!connAutoCommit.booleanValue() &amp;&amp; !conn.isReadOnly()) {<a name="line.426"></a>
<span class="sourceLineNo">427</span>                conn.rollback();<a name="line.427"></a>
<span class="sourceLineNo">428</span>            }<a name="line.428"></a>
<span class="sourceLineNo">429</span>        }<a name="line.429"></a>
<span class="sourceLineNo">430</span><a name="line.430"></a>
<span class="sourceLineNo">431</span>        conn.clearWarnings();<a name="line.431"></a>
<span class="sourceLineNo">432</span><a name="line.432"></a>
<span class="sourceLineNo">433</span>        // DBCP-97 / DBCP-399 / DBCP-351 Idle connections in the pool should<a name="line.433"></a>
<span class="sourceLineNo">434</span>        // have autoCommit enabled<a name="line.434"></a>
<span class="sourceLineNo">435</span>        if (autoCommitOnReturn) {<a name="line.435"></a>
<span class="sourceLineNo">436</span>            if (connAutoCommit == null) {<a name="line.436"></a>
<span class="sourceLineNo">437</span>                connAutoCommit = Boolean.valueOf(conn.getAutoCommit());<a name="line.437"></a>
<span class="sourceLineNo">438</span>            }<a name="line.438"></a>
<span class="sourceLineNo">439</span>            if (!connAutoCommit.booleanValue()) {<a name="line.439"></a>
<span class="sourceLineNo">440</span>                conn.setAutoCommit(true);<a name="line.440"></a>
<span class="sourceLineNo">441</span>            }<a name="line.441"></a>
<span class="sourceLineNo">442</span>        }<a name="line.442"></a>
<span class="sourceLineNo">443</span><a name="line.443"></a>
<span class="sourceLineNo">444</span>        conn.passivate();<a name="line.444"></a>
<span class="sourceLineNo">445</span>    }<a name="line.445"></a>
<span class="sourceLineNo">446</span><a name="line.446"></a>
<span class="sourceLineNo">447</span>    public void setAutoCommitOnReturn(final boolean autoCommitOnReturn) {<a name="line.447"></a>
<span class="sourceLineNo">448</span>        this.autoCommitOnReturn = autoCommitOnReturn;<a name="line.448"></a>
<span class="sourceLineNo">449</span>    }<a name="line.449"></a>
<span class="sourceLineNo">450</span><a name="line.450"></a>
<span class="sourceLineNo">451</span>    public void setCacheState(final boolean cacheState) {<a name="line.451"></a>
<span class="sourceLineNo">452</span>        this.cacheState = cacheState;<a name="line.452"></a>
<span class="sourceLineNo">453</span>    }<a name="line.453"></a>
<span class="sourceLineNo">454</span><a name="line.454"></a>
<span class="sourceLineNo">455</span>    /**<a name="line.455"></a>
<span class="sourceLineNo">456</span>     * Sets the SQL statements I use to initialize newly created {@link Connection}s. Using {@code null} turns off<a name="line.456"></a>
<span class="sourceLineNo">457</span>     * connection initialization.<a name="line.457"></a>
<span class="sourceLineNo">458</span>     *<a name="line.458"></a>
<span class="sourceLineNo">459</span>     * @param connectionInitSqls<a name="line.459"></a>
<span class="sourceLineNo">460</span>     *            SQL statement to initialize {@link Connection}s.<a name="line.460"></a>
<span class="sourceLineNo">461</span>     */<a name="line.461"></a>
<span class="sourceLineNo">462</span>    public void setConnectionInitSql(final Collection&lt;String&gt; connectionInitSqls) {<a name="line.462"></a>
<span class="sourceLineNo">463</span>        this.connectionInitSqls = connectionInitSqls;<a name="line.463"></a>
<span class="sourceLineNo">464</span>    }<a name="line.464"></a>
<span class="sourceLineNo">465</span><a name="line.465"></a>
<span class="sourceLineNo">466</span>    /**<a name="line.466"></a>
<span class="sourceLineNo">467</span>     * Sets the default "auto commit" setting for borrowed {@link Connection}s<a name="line.467"></a>
<span class="sourceLineNo">468</span>     *<a name="line.468"></a>
<span class="sourceLineNo">469</span>     * @param defaultAutoCommit<a name="line.469"></a>
<span class="sourceLineNo">470</span>     *            the default "auto commit" setting for borrowed {@link Connection}s<a name="line.470"></a>
<span class="sourceLineNo">471</span>     */<a name="line.471"></a>
<span class="sourceLineNo">472</span>    public void setDefaultAutoCommit(final Boolean defaultAutoCommit) {<a name="line.472"></a>
<span class="sourceLineNo">473</span>        this.defaultAutoCommit = defaultAutoCommit;<a name="line.473"></a>
<span class="sourceLineNo">474</span>    }<a name="line.474"></a>
<span class="sourceLineNo">475</span><a name="line.475"></a>
<span class="sourceLineNo">476</span>    /**<a name="line.476"></a>
<span class="sourceLineNo">477</span>     * Sets the default "catalog" setting for borrowed {@link Connection}s<a name="line.477"></a>
<span class="sourceLineNo">478</span>     *<a name="line.478"></a>
<span class="sourceLineNo">479</span>     * @param defaultCatalog<a name="line.479"></a>
<span class="sourceLineNo">480</span>     *            the default "catalog" setting for borrowed {@link Connection}s<a name="line.480"></a>
<span class="sourceLineNo">481</span>     */<a name="line.481"></a>
<span class="sourceLineNo">482</span>    public void setDefaultCatalog(final String defaultCatalog) {<a name="line.482"></a>
<span class="sourceLineNo">483</span>        this.defaultCatalog = defaultCatalog;<a name="line.483"></a>
<span class="sourceLineNo">484</span>    }<a name="line.484"></a>
<span class="sourceLineNo">485</span><a name="line.485"></a>
<span class="sourceLineNo">486</span>    public void setDefaultQueryTimeout(final Integer defaultQueryTimeoutSeconds) {<a name="line.486"></a>
<span class="sourceLineNo">487</span>        this.defaultQueryTimeoutSeconds = defaultQueryTimeoutSeconds;<a name="line.487"></a>
<span class="sourceLineNo">488</span>    }<a name="line.488"></a>
<span class="sourceLineNo">489</span>    /**<a name="line.489"></a>
<span class="sourceLineNo">490</span>     * Sets the default "read only" setting for borrowed {@link Connection}s<a name="line.490"></a>
<span class="sourceLineNo">491</span>     *<a name="line.491"></a>
<span class="sourceLineNo">492</span>     * @param defaultReadOnly<a name="line.492"></a>
<span class="sourceLineNo">493</span>     *            the default "read only" setting for borrowed {@link Connection}s<a name="line.493"></a>
<span class="sourceLineNo">494</span>     */<a name="line.494"></a>
<span class="sourceLineNo">495</span>    public void setDefaultReadOnly(final Boolean defaultReadOnly) {<a name="line.495"></a>
<span class="sourceLineNo">496</span>        this.defaultReadOnly = defaultReadOnly;<a name="line.496"></a>
<span class="sourceLineNo">497</span>    }<a name="line.497"></a>
<span class="sourceLineNo">498</span><a name="line.498"></a>
<span class="sourceLineNo">499</span>    /**<a name="line.499"></a>
<span class="sourceLineNo">500</span>     * Sets the default "schema" setting for borrowed {@link Connection}s<a name="line.500"></a>
<span class="sourceLineNo">501</span>     *<a name="line.501"></a>
<span class="sourceLineNo">502</span>     * @param defaultSchema<a name="line.502"></a>
<span class="sourceLineNo">503</span>     *            the default "schema" setting for borrowed {@link Connection}s<a name="line.503"></a>
<span class="sourceLineNo">504</span>     * @since 2.5.0<a name="line.504"></a>
<span class="sourceLineNo">505</span>     */<a name="line.505"></a>
<span class="sourceLineNo">506</span>    public void setDefaultSchema(final String defaultSchema) {<a name="line.506"></a>
<span class="sourceLineNo">507</span>        this.defaultSchema = defaultSchema;<a name="line.507"></a>
<span class="sourceLineNo">508</span>    }<a name="line.508"></a>
<span class="sourceLineNo">509</span><a name="line.509"></a>
<span class="sourceLineNo">510</span>    /**<a name="line.510"></a>
<span class="sourceLineNo">511</span>     * Sets the default "Transaction Isolation" setting for borrowed {@link Connection}s<a name="line.511"></a>
<span class="sourceLineNo">512</span>     *<a name="line.512"></a>
<span class="sourceLineNo">513</span>     * @param defaultTransactionIsolation<a name="line.513"></a>
<span class="sourceLineNo">514</span>     *            the default "Transaction Isolation" setting for returned {@link Connection}s<a name="line.514"></a>
<span class="sourceLineNo">515</span>     */<a name="line.515"></a>
<span class="sourceLineNo">516</span>    public void setDefaultTransactionIsolation(final int defaultTransactionIsolation) {<a name="line.516"></a>
<span class="sourceLineNo">517</span>        this.defaultTransactionIsolation = defaultTransactionIsolation;<a name="line.517"></a>
<span class="sourceLineNo">518</span>    }<a name="line.518"></a>
<span class="sourceLineNo">519</span><a name="line.519"></a>
<span class="sourceLineNo">520</span>    /**<a name="line.520"></a>
<span class="sourceLineNo">521</span>     * @param disconnectionSqlCodes<a name="line.521"></a>
<span class="sourceLineNo">522</span>     *            The disconnection SQL codes.<a name="line.522"></a>
<span class="sourceLineNo">523</span>     * @see #getDisconnectionSqlCodes()<a name="line.523"></a>
<span class="sourceLineNo">524</span>     * @since 2.1<a name="line.524"></a>
<span class="sourceLineNo">525</span>     */<a name="line.525"></a>
<span class="sourceLineNo">526</span>    public void setDisconnectionSqlCodes(final Collection&lt;String&gt; disconnectionSqlCodes) {<a name="line.526"></a>
<span class="sourceLineNo">527</span>        this.disconnectionSqlCodes = disconnectionSqlCodes;<a name="line.527"></a>
<span class="sourceLineNo">528</span>    }<a name="line.528"></a>
<span class="sourceLineNo">529</span><a name="line.529"></a>
<span class="sourceLineNo">530</span>    /**<a name="line.530"></a>
<span class="sourceLineNo">531</span>     * @param autoCommitOnReturn Whether to auto-commit on return.<a name="line.531"></a>
<span class="sourceLineNo">532</span>     * @deprecated Use {@link #setAutoCommitOnReturn(boolean)}.<a name="line.532"></a>
<span class="sourceLineNo">533</span>     */<a name="line.533"></a>
<span class="sourceLineNo">534</span>    @Deprecated<a name="line.534"></a>
<span class="sourceLineNo">535</span>    public void setEnableAutoCommitOnReturn(final boolean autoCommitOnReturn) {<a name="line.535"></a>
<span class="sourceLineNo">536</span>        this.autoCommitOnReturn = autoCommitOnReturn;<a name="line.536"></a>
<span class="sourceLineNo">537</span>    }<a name="line.537"></a>
<span class="sourceLineNo">538</span><a name="line.538"></a>
<span class="sourceLineNo">539</span>    /**<a name="line.539"></a>
<span class="sourceLineNo">540</span>     * @see #isFastFailValidation()<a name="line.540"></a>
<span class="sourceLineNo">541</span>     * @param fastFailValidation<a name="line.541"></a>
<span class="sourceLineNo">542</span>     *            true means connections created by this factory will fast fail validation<a name="line.542"></a>
<span class="sourceLineNo">543</span>     * @since 2.1<a name="line.543"></a>
<span class="sourceLineNo">544</span>     */<a name="line.544"></a>
<span class="sourceLineNo">545</span>    public void setFastFailValidation(final boolean fastFailValidation) {<a name="line.545"></a>
<span class="sourceLineNo">546</span>        this.fastFailValidation = fastFailValidation;<a name="line.546"></a>
<span class="sourceLineNo">547</span>    }<a name="line.547"></a>
<span class="sourceLineNo">548</span><a name="line.548"></a>
<span class="sourceLineNo">549</span>    /**<a name="line.549"></a>
<span class="sourceLineNo">550</span>     * Sets the maximum lifetime in milliseconds of a connection after which the connection will always fail activation,<a name="line.550"></a>
<span class="sourceLineNo">551</span>     * passivation and validation. A value of zero or less indicates an infinite lifetime. The default value is -1.<a name="line.551"></a>
<span class="sourceLineNo">552</span>     *<a name="line.552"></a>
<span class="sourceLineNo">553</span>     * @param maxConnLifetimeMillis<a name="line.553"></a>
<span class="sourceLineNo">554</span>     *            The maximum lifetime in milliseconds.<a name="line.554"></a>
<span class="sourceLineNo">555</span>     */<a name="line.555"></a>
<span class="sourceLineNo">556</span>    public void setMaxConnLifetimeMillis(final long maxConnLifetimeMillis) {<a name="line.556"></a>
<span class="sourceLineNo">557</span>        this.maxConnLifetimeMillis = maxConnLifetimeMillis;<a name="line.557"></a>
<span class="sourceLineNo">558</span>    }<a name="line.558"></a>
<span class="sourceLineNo">559</span><a name="line.559"></a>
<span class="sourceLineNo">560</span>    /**<a name="line.560"></a>
<span class="sourceLineNo">561</span>     * Sets the maximum number of open prepared statements.<a name="line.561"></a>
<span class="sourceLineNo">562</span>     *<a name="line.562"></a>
<span class="sourceLineNo">563</span>     * @param maxOpenPreparedStatements<a name="line.563"></a>
<span class="sourceLineNo">564</span>     *            The maximum number of open prepared statements.<a name="line.564"></a>
<span class="sourceLineNo">565</span>     */<a name="line.565"></a>
<span class="sourceLineNo">566</span>    public void setMaxOpenPreparedStatements(final int maxOpenPreparedStatements) {<a name="line.566"></a>
<span class="sourceLineNo">567</span>        this.maxOpenPreparedStatements = maxOpenPreparedStatements;<a name="line.567"></a>
<span class="sourceLineNo">568</span>    }<a name="line.568"></a>
<span class="sourceLineNo">569</span><a name="line.569"></a>
<span class="sourceLineNo">570</span>    /**<a name="line.570"></a>
<span class="sourceLineNo">571</span>     * Deprecated due to typo in method name.<a name="line.571"></a>
<span class="sourceLineNo">572</span>     *<a name="line.572"></a>
<span class="sourceLineNo">573</span>     * @param maxOpenPreparedStatements<a name="line.573"></a>
<span class="sourceLineNo">574</span>     *            The maximum number of open prepared statements.<a name="line.574"></a>
<span class="sourceLineNo">575</span>     * @deprecated Use {@link #setMaxOpenPreparedStatements(int)}.<a name="line.575"></a>
<span class="sourceLineNo">576</span>     */<a name="line.576"></a>
<span class="sourceLineNo">577</span>    @Deprecated // Due to typo in method name.<a name="line.577"></a>
<span class="sourceLineNo">578</span>    public void setMaxOpenPrepatedStatements(final int maxOpenPreparedStatements) {<a name="line.578"></a>
<span class="sourceLineNo">579</span>        setMaxOpenPreparedStatements(maxOpenPreparedStatements);<a name="line.579"></a>
<span class="sourceLineNo">580</span>    }<a name="line.580"></a>
<span class="sourceLineNo">581</span><a name="line.581"></a>
<span class="sourceLineNo">582</span>    /**<a name="line.582"></a>
<span class="sourceLineNo">583</span>     * Sets the {@link ObjectPool} in which to pool {@link Connection}s.<a name="line.583"></a>
<span class="sourceLineNo">584</span>     *<a name="line.584"></a>
<span class="sourceLineNo">585</span>     * @param pool<a name="line.585"></a>
<span class="sourceLineNo">586</span>     *            the {@link ObjectPool} in which to pool those {@link Connection}s<a name="line.586"></a>
<span class="sourceLineNo">587</span>     */<a name="line.587"></a>
<span class="sourceLineNo">588</span>    public synchronized void setPool(final ObjectPool&lt;PoolableConnection&gt; pool) {<a name="line.588"></a>
<span class="sourceLineNo">589</span>        if (null != this.pool &amp;&amp; pool != this.pool) {<a name="line.589"></a>
<span class="sourceLineNo">590</span>            try {<a name="line.590"></a>
<span class="sourceLineNo">591</span>                this.pool.close();<a name="line.591"></a>
<span class="sourceLineNo">592</span>            } catch (final Exception e) {<a name="line.592"></a>
<span class="sourceLineNo">593</span>                // ignored !?!<a name="line.593"></a>
<span class="sourceLineNo">594</span>            }<a name="line.594"></a>
<span class="sourceLineNo">595</span>        }<a name="line.595"></a>
<span class="sourceLineNo">596</span>        this.pool = pool;<a name="line.596"></a>
<span class="sourceLineNo">597</span>    }<a name="line.597"></a>
<span class="sourceLineNo">598</span><a name="line.598"></a>
<span class="sourceLineNo">599</span>    public void setPoolStatements(final boolean poolStatements) {<a name="line.599"></a>
<span class="sourceLineNo">600</span>        this.poolStatements = poolStatements;<a name="line.600"></a>
<span class="sourceLineNo">601</span>    }<a name="line.601"></a>
<span class="sourceLineNo">602</span><a name="line.602"></a>
<span class="sourceLineNo">603</span>    /**<a name="line.603"></a>
<span class="sourceLineNo">604</span>     * Sets whether the pool of statements (which was enabled with {@link #setPoolStatements(boolean)}) should<a name="line.604"></a>
<span class="sourceLineNo">605</span>     * be cleared when the connection is returned to its pool. Default is false.<a name="line.605"></a>
<span class="sourceLineNo">606</span>     *<a name="line.606"></a>
<span class="sourceLineNo">607</span>     * @param clearStatementPoolOnReturn clear or not<a name="line.607"></a>
<span class="sourceLineNo">608</span>     * @since 2.8.0<a name="line.608"></a>
<span class="sourceLineNo">609</span>     */<a name="line.609"></a>
<span class="sourceLineNo">610</span>    public void setClearStatementPoolOnReturn(final boolean clearStatementPoolOnReturn) {<a name="line.610"></a>
<span class="sourceLineNo">611</span>        this.clearStatementPoolOnReturn = clearStatementPoolOnReturn;<a name="line.611"></a>
<span class="sourceLineNo">612</span>    }<a name="line.612"></a>
<span class="sourceLineNo">613</span><a name="line.613"></a>
<span class="sourceLineNo">614</span>    public void setRollbackOnReturn(final boolean rollbackOnReturn) {<a name="line.614"></a>
<span class="sourceLineNo">615</span>        this.rollbackOnReturn = rollbackOnReturn;<a name="line.615"></a>
<span class="sourceLineNo">616</span>    }<a name="line.616"></a>
<span class="sourceLineNo">617</span><a name="line.617"></a>
<span class="sourceLineNo">618</span>    /**<a name="line.618"></a>
<span class="sourceLineNo">619</span>     * Sets the query I use to {@link #validateObject validate} {@link Connection}s. Should return at least one row. If<a name="line.619"></a>
<span class="sourceLineNo">620</span>     * not specified, {@link Connection#isValid(int)} will be used to validate connections.<a name="line.620"></a>
<span class="sourceLineNo">621</span>     *<a name="line.621"></a>
<span class="sourceLineNo">622</span>     * @param validationQuery<a name="line.622"></a>
<span class="sourceLineNo">623</span>     *            a query to use to {@link #validateObject validate} {@link Connection}s.<a name="line.623"></a>
<span class="sourceLineNo">624</span>     */<a name="line.624"></a>
<span class="sourceLineNo">625</span>    public void setValidationQuery(final String validationQuery) {<a name="line.625"></a>
<span class="sourceLineNo">626</span>        this.validationQuery = validationQuery;<a name="line.626"></a>
<span class="sourceLineNo">627</span>    }<a name="line.627"></a>
<span class="sourceLineNo">628</span><a name="line.628"></a>
<span class="sourceLineNo">629</span>    /**<a name="line.629"></a>
<span class="sourceLineNo">630</span>     * Sets the validation query timeout, the amount of time, in seconds, that connection validation will wait for a<a name="line.630"></a>
<span class="sourceLineNo">631</span>     * response from the database when executing a validation query. Use a value less than or equal to 0 for no timeout.<a name="line.631"></a>
<span class="sourceLineNo">632</span>     *<a name="line.632"></a>
<span class="sourceLineNo">633</span>     * @param validationQueryTimeoutSeconds<a name="line.633"></a>
<span class="sourceLineNo">634</span>     *            new validation query timeout value in seconds<a name="line.634"></a>
<span class="sourceLineNo">635</span>     */<a name="line.635"></a>
<span class="sourceLineNo">636</span>    public void setValidationQueryTimeout(final int validationQueryTimeoutSeconds) {<a name="line.636"></a>
<span class="sourceLineNo">637</span>        this.validationQueryTimeoutSeconds = validationQueryTimeoutSeconds;<a name="line.637"></a>
<span class="sourceLineNo">638</span>    }<a name="line.638"></a>
<span class="sourceLineNo">639</span><a name="line.639"></a>
<span class="sourceLineNo">640</span>    public void validateConnection(final PoolableConnection conn) throws SQLException {<a name="line.640"></a>
<span class="sourceLineNo">641</span>        if (conn.isClosed()) {<a name="line.641"></a>
<span class="sourceLineNo">642</span>            throw new SQLException("validateConnection: connection closed");<a name="line.642"></a>
<span class="sourceLineNo">643</span>        }<a name="line.643"></a>
<span class="sourceLineNo">644</span>        conn.validate(validationQuery, validationQueryTimeoutSeconds);<a name="line.644"></a>
<span class="sourceLineNo">645</span>    }<a name="line.645"></a>
<span class="sourceLineNo">646</span><a name="line.646"></a>
<span class="sourceLineNo">647</span>    private void validateLifetime(final PooledObject&lt;PoolableConnection&gt; p) throws Exception {<a name="line.647"></a>
<span class="sourceLineNo">648</span>        if (maxConnLifetimeMillis &gt; 0) {<a name="line.648"></a>
<span class="sourceLineNo">649</span>            final long lifetime = System.currentTimeMillis() - p.getCreateTime();<a name="line.649"></a>
<span class="sourceLineNo">650</span>            if (lifetime &gt; maxConnLifetimeMillis) {<a name="line.650"></a>
<span class="sourceLineNo">651</span>                throw new LifetimeExceededException(Utils.getMessage("connectionFactory.lifetimeExceeded",<a name="line.651"></a>
<span class="sourceLineNo">652</span>                        Long.valueOf(lifetime), Long.valueOf(maxConnLifetimeMillis)));<a name="line.652"></a>
<span class="sourceLineNo">653</span>            }<a name="line.653"></a>
<span class="sourceLineNo">654</span>        }<a name="line.654"></a>
<span class="sourceLineNo">655</span>    }<a name="line.655"></a>
<span class="sourceLineNo">656</span><a name="line.656"></a>
<span class="sourceLineNo">657</span>    @Override<a name="line.657"></a>
<span class="sourceLineNo">658</span>    public boolean validateObject(final PooledObject&lt;PoolableConnection&gt; p) {<a name="line.658"></a>
<span class="sourceLineNo">659</span>        try {<a name="line.659"></a>
<span class="sourceLineNo">660</span>            validateLifetime(p);<a name="line.660"></a>
<span class="sourceLineNo">661</span><a name="line.661"></a>
<span class="sourceLineNo">662</span>            validateConnection(p.getObject());<a name="line.662"></a>
<span class="sourceLineNo">663</span>            return true;<a name="line.663"></a>
<span class="sourceLineNo">664</span>        } catch (final Exception e) {<a name="line.664"></a>
<span class="sourceLineNo">665</span>            if (log.isDebugEnabled()) {<a name="line.665"></a>
<span class="sourceLineNo">666</span>                log.debug(Utils.getMessage("poolableConnectionFactory.validateObject.fail"), e);<a name="line.666"></a>
<span class="sourceLineNo">667</span>            }<a name="line.667"></a>
<span class="sourceLineNo">668</span>            return false;<a name="line.668"></a>
<span class="sourceLineNo">669</span>        }<a name="line.669"></a>
<span class="sourceLineNo">670</span>    }<a name="line.670"></a>
<span class="sourceLineNo">671</span>}<a name="line.671"></a>




























































</pre>
</div>
</body>
</html>
